/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.10 Revision 1.32
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.10 2009/01/12 19:40:34 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.32 2010/01/11 17:27:35 scarabeus Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15# we want opengl optional in each koffice package 15inherit kde4-base versionator
16if [[ $KMNAME = koffice ]]; then 16
17 case ${PN} in 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18 koffice-data) 18
19 ;; 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
20 *) 20
21 OPENGL_REQUIRED=optional 21# Add khelpcenter dependency when installing handbooks
22 ;; 22if [[ ${PN} != khelpcenter ]] && has handbook ${IUSE//+}; then
23 esac 23 RDEPEND+=" handbook? ( $(add_kdebase_dep khelpcenter) )"
24fi 24fi
25
26inherit kde4-base versionator
27
28EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
29
30if [[ -z ${KMNAME} ]]; then
31 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
32fi
33
34case ${KDEBASE} in
35 kde-base)
36 HOMEPAGE="http://www.kde.org/"
37 LICENSE="GPL-2"
38 ;;
39 koffice)
40 HOMEPAGE="http://www.koffice.org/"
41 LICENSE="GPL-2"
42 ;;
43esac
44 25
45# Add dependencies that all packages in a certain module share. 26# Add dependencies that all packages in a certain module share.
46case ${KMNAME} in 27case ${KMNAME} in
47 kdebase|kdebase-workspace|kdebase-runtime) 28 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
48 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 29 COMMONDEPEND+=" >=kde-base/qimageblitz-0.0.4"
49 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4"
50 ;; 30 ;;
51 kdepim) 31 kdepim|kdepim-runtime)
52 DEPEND="${DEPEND} dev-libs/boost app-office/akonadi-server" 32 COMMONDEPEND+=" $(add_kdebase_dep kdepimlibs)"
53 RDEPEND="${RDEPEND} dev-libs/boost"
54 if [[ $PN != kode ]]; then
55 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}"
56 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}"
57 fi
58 case ${PN} in 33 case ${PN} in
59 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 34 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
60 IUSE="+kontact" 35 IUSE+=" +kontact"
61 DEPEND="${DEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT} )" 36 if ! slot_is_at_least 4.4 ${SLOT}; then
62 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT} )" 37 RDEPEND+=" kontact? ( $(add_kdebase_dep kontactinterfaces) )"
38 fi
63 ;; 39 ;;
64 esac 40 esac
65 ;; 41 ;;
66 kdegames) 42 kdegames)
67 if [[ $PN != libkdegames ]]; then 43 if [[ ${PN} != libkdegames ]]; then
68 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}" 44 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
69 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}"
70 fi 45 fi
71 ;; 46 ;;
72 koffice) 47 koffice)
73 case ${PV} in 48 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
74 9999*) DEPEND="${DEPEND} !app-office/${PN}:2" ;; 49 RDEPEND+="
75 1.9*|2*) DEPEND="${DEPEND} !app-office/${PN}:live" ;;
76 esac
77 DEPEND="${DEPEND}
78 !app-office/${PN}:0 50 !app-office/${PN}:0
79 !app-office/koffice:0 51 !app-office/koffice:0
80 !app-office/koffice-meta:0" 52 !app-office/koffice-meta:0
81 case ${PN} in 53 "
82 koffice-data) 54 if has openexr ${IUSE//+}; then
83 DEPEND="${DEPEND} media-libs/lcms" 55 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
84 RDEPEND="${RDEPEND} media-libs/lcms" 56 else
85 ;; 57 COMMONDEPEND+=" media-gfx/imagemagick"
86 *) 58 fi
87 IUSE="+crypt" 59
88 DEPEND="${DEPEND} crypt? ( >=app-crypt/qca-2 )" 60 COMMONDEPEND+="
89 RDEPEND="${RDEPEND} crypt? ( >=app-crypt/qca-2 )" 61 dev-cpp/eigen:2
90 if [[ $PN != koffice-libs ]]; then 62 media-libs/fontconfig
63 media-libs/freetype:2
64 "
65 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
91 DEPEND="${DEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 66 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
92 RDEPEND="${RDEPEND} >=app-office/koffice-libs-${PV}:${SLOT}"
93 fi 67 fi
68 ;;
69esac
70
71DEPEND+=" ${COMMONDEPEND}"
72RDEPEND+=" ${COMMONDEPEND}"
73unset COMMONDEPEND
74
75debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
76debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
77
78# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
79case ${BUILD_TYPE} in
80 live)
81 case ${KMNAME} in
82 extragear*|playground*)
83 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
84 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
94 ;; 85 ;;
95 esac 86 esac
96 ;; 87 ;;
97esac 88esac
98
99debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
100debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
101 89
102# @ECLASS-VARIABLE: KMNAME 90# @ECLASS-VARIABLE: KMNAME
103# @DESCRIPTION: 91# @DESCRIPTION:
104# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it 92# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
105# _before_ inheriting this eclass, (unlike the other parameters), since it's 93# _before_ inheriting this eclass, (unlike the other parameters), since it's
118# If set to "true", $KMMODULE doesn't have to be defined. 106# If set to "true", $KMMODULE doesn't have to be defined.
119# 107#
120# Example usage: If you're installing subdirectories of a package, like plugins, 108# Example usage: If you're installing subdirectories of a package, like plugins,
121# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 109# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
122# set KMNOMODULE="true". 110# set KMNOMODULE="true".
123if [[ -z $KMMODULE && $KMNOMODULE != true ]]; then 111if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then
124 KMMODULE=$PN 112 KMMODULE=${PN}
125fi 113fi
126 114
127# @ECLASS-VARIABLE: KMEXTRA 115# @ECLASS-VARIABLE: KMEXTRA
128# @DESCRIPTION: 116# @DESCRIPTION:
129# All subdirectories listed here will be extracted, compiled & installed. 117# All subdirectories listed here will be extracted, compiled & installed.
130# $KMMODULE is always added to $KMEXTRA. 118# $KMMODULE is always added to $KMEXTRA.
131# If the htmlhandbook USE-flag is set, and if this directory exists, 119# If the handbook USE-flag is set, and if this directory exists,
132# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 120# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be
133# handled in the ebuild. 121# handled in the ebuild.
134# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 122# If the documentation is in a different subdirectory, you should add it to KMEXTRA.
135 123
136# @ECLASS-VARIABLE: KMCOMPILEONLY 124# @ECLASS-VARIABLE: KMCOMPILEONLY
151# @FUNCTION: kde4-meta_pkg_setup 139# @FUNCTION: kde4-meta_pkg_setup
152# @DESCRIPTION: 140# @DESCRIPTION:
153# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 141# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in
154# split ebuilds. 142# split ebuilds.
155kde4-meta_pkg_setup() { 143kde4-meta_pkg_setup() {
144 debug-print-function ${FUNCNAME} "$@"
145
156 kde4-base_pkg_setup 146 kde4-base_pkg_setup
157} 147}
158 148
159# @FUNCTION: kde4-meta_src_unpack 149# @FUNCTION: kde4-meta_src_unpack
160# @DESCRIPTION: 150# @DESCRIPTION:
161# This function unpacks the source for split ebuilds. See also 151# This function unpacks the source for split ebuilds. See also
162# kde4-meta-src_extract. 152# kde4-meta-src_extract.
163kde4-meta_src_unpack() { 153kde4-meta_src_unpack() {
164 debug-print-function ${FUNCNAME} "$@" 154 debug-print-function ${FUNCNAME} "$@"
155
165 if [[ $BUILD_TYPE = live ]]; then 156 if [[ ${BUILD_TYPE} = live ]]; then
166 migrate_store_dir 157 migrate_store_dir
167 S="${WORKDIR}/${PN}-${PV}" 158 S="${WORKDIR}/${P}"
168 mkdir -p "${S}" 159 mkdir -p "${S}"
169 ESVN_RESTRICT="export" subversion_src_unpack 160 ESVN_RESTRICT="export" subversion_src_unpack
170 subversion_wc_info 161 subversion_wc_info
171 subversion_bootstrap 162 subversion_bootstrap
172 kde4-meta_src_extract 163 kde4-meta_src_extract
181# @DESCRIPTION: 172# @DESCRIPTION:
182# A function to unpack the source for a split KDE ebuild. 173# A function to unpack the source for a split KDE ebuild.
183# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 174# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
184# KMTARPARAMS. 175# KMTARPARAMS.
185kde4-meta_src_extract() { 176kde4-meta_src_extract() {
177 debug-print-function ${FUNCNAME} "$@"
178
186 if [[ $BUILD_TYPE = live ]]; then 179 if [[ ${BUILD_TYPE} = live ]]; then
187 local rsync_options subdir kmnamedir targetdir 180 local rsync_options subdir kmnamedir targetdir
188 # Export working copy to ${S} 181 # Export working copy to ${S}
189 einfo "Exporting parts of working copy to ${S}" 182 einfo "Exporting parts of working copy to ${S}"
190 kde4-meta_create_extractlists 183 kde4-meta_create_extractlists
191 184
199 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 192 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \
200 || die "${ESVN}: can't export cmake files to '${S}'." 193 || die "${ESVN}: can't export cmake files to '${S}'."
201 fi 194 fi
202 # Copy all subdirectories 195 # Copy all subdirectories
203 for subdir in $(__list_needed_subdirectories); do 196 for subdir in $(__list_needed_subdirectories); do
204 targetdir="" 197 targetdir=""
205 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 198 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
206 continue 199 continue
207 fi 200 fi
208 201
209 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 202 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
210 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 203 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
211 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 204 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
212 done 205 done
213 206
214 if [[ $KMNAME = kdebase-runtime && $PN != kdebase-data ]]; then 207 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
215 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 208 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
216 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 209 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
217 fi 210 fi
218 else 211 else
219 local abort tarball tarfile f extractlist 212 local abort tarball tarfile f extractlist moduleprefix postfix
213 case ${PV} in
214 4.3.8[05] | 4.3.9[0568])
215 # block for normally packed upstream unstable snapshots
216 KMTARPARAMS+=" --bzip2" # bz2
217 postfix="bz2"
218 ;;
219 4.3.[6-9]*)
220 # Not passing --xz, as it doesn't work with stable tar
221 KMTARPARAMS+=" --use-compress-program=xz" # xz
222 postfix="xz"
223 ;;
224 *)
225 KMTARPARAMS+=" --bzip2" # bz2
226 postfix="bz2"
227 ;;
228 esac
220 case $KMNAME in 229 case ${KMNAME} in
221 kdebase-apps) 230 kdebase-apps)
222 tarball="${KMNAME#-apps}-${PV}.tar.bz2" 231 # kdebase/apps -> kdebase-apps
232 tarball="kdebase-${PV}.tar.${postfix}"
233 # Go one level deeper for kdebase-apps in tarballs
234 moduleprefix=apps/
235 KMTARPARAMS+=" --transform=s|apps/||"
223 ;; 236 ;;
224 *) 237 *)
238 # Create tarball name from module name (this is the default)
225 tarball="${KMNAME}-${PV}.tar.bz2" 239 tarball="${KMNAME}-${PV}.tar.${postfix}"
226 ;; 240 ;;
227 esac 241 esac
242
243 # Full path to source tarball
228 tarfile="${DISTDIR}"/${tarball} 244 tarfile="${DISTDIR}/${tarball}"
245
246 # Detect real toplevel dir from tarball name - it will be used upon extraction
247 # and in __list_needed_subdirectories
248 topdir="${tarball%.tar.*}/"
229 249
230 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 250 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
231 251
232 kde4-meta_create_extractlists 252 kde4-meta_create_extractlists
233 253
234 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 254 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
235 AUTHORS COPYING INSTALL README NEWS ChangeLog 255 AUTHORS COPYING INSTALL README NEWS ChangeLog
236 do 256 do
237 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 257 extractlist+=" ${topdir}${moduleprefix}${f}"
238 done 258 done
239 extractlist="${extractlist} $(__list_needed_subdirectories)" 259 extractlist+=" $(__list_needed_subdirectories)"
240 KMTARPARAMS="${KMTARPARAMS} -j"
241 260
242 pushd "${WORKDIR}" > /dev/null 261 pushd "${WORKDIR}" > /dev/null
243 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf $tarfile $KMTARPARAMS $extractlist >&2 262 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
244 tar -xpf $tarfile $KMTARPARAMS $extractlist 2> /dev/null 263 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
245 264
246 # Default $S is based on $P; rename the extracted directory to match $S 265 # Default $S is based on $P; rename the extracted directory to match $S if necessary
247 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 266 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
248 267
249 popd > /dev/null 268 popd > /dev/null
250 269
251 eend $? 270 eend $?
271
272 # We need to clear it here to make verification below work
273 unset moduleprefix
252 274
253 if [[ -n ${KDE4_STRICTER} ]]; then 275 if [[ -n ${KDE4_STRICTER} ]]; then
254 for f in $(__list_needed_subdirectories fatal); do 276 for f in $(__list_needed_subdirectories fatal); do
255 if [[ ! -e ${S}/${f#*/} ]]; then 277 if [[ ! -e "${S}/${f#*/}" ]]; then
256 eerror "'${f#*/}' is missing" 278 eerror "'${f#*/}' is missing"
257 abort=true 279 abort=true
258 fi 280 fi
259 done 281 done
260 [[ -n ${abort} ]] && die "There were missing files." 282 [[ -n ${abort} ]] && die "There were missing files."
261 fi 283 fi
262 kde4-base_src_unpack 284
263 fi 285 # We don't need it anymore
264 # fix koffice linking 286 unset topdir
265 if [[ $KMNAME = koffice ]]; then
266 koffice_fix_libraries
267 fi 287 fi
268} 288}
269 289
270# @FUNCTION: kde4-meta_create_extractlists 290# @FUNCTION: kde4-meta_create_extractlists
271# @DESCRIPTION: 291# @DESCRIPTION:
273# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 293# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
274# KMEXTRACTONLY and KMTARPARAMS. 294# KMEXTRACTONLY and KMTARPARAMS.
275kde4-meta_create_extractlists() { 295kde4-meta_create_extractlists() {
276 debug-print-function ${FUNCNAME} "$@" 296 debug-print-function ${FUNCNAME} "$@"
277 297
298 # TODO change to KMEXTRA for more strict check
278 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 299 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then
279 # We use the basename of $KMMODULE because $KMMODULE can contain 300 # We use the basename of $KMMODULE because $KMMODULE can contain
280 # the path to the module subdirectory. 301 # the path to the module subdirectory.
281 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 302 KMEXTRA_NONFATAL+="
303 doc/${KMMODULE##*/}"
282 fi 304 fi
283 305
284 # Add some CMake-files to KMEXTRACTONLY. 306 # Add some CMake-files to KMEXTRACTONLY.
285 # Note that this actually doesn't include KMEXTRA handling. 307 # Note that this actually doesn't include KMEXTRA handling.
286 # In those cases you should care to add the relevant files to KMEXTRACTONLY 308 # In those cases you should care to add the relevant files to KMEXTRACTONLY
287 case ${KMNAME} in 309 case ${KMNAME} in
288 kdebase) 310 kdebase)
289 KMEXTRACTONLY="${KMEXTRACTONLY} 311 KMEXTRACTONLY+="
290 apps/config-apps.h.cmake 312 apps/config-apps.h.cmake
291 apps/ConfigureChecks.cmake" 313 apps/ConfigureChecks.cmake"
292 ;; 314 ;;
293 kdebase-apps) 315 kdebase-apps)
294 KMEXTRACTONLY="${KMEXTRACTONLY} 316 KMEXTRACTONLY+="
295 config-apps.h.cmake 317 config-apps.h.cmake
296 ConfigureChecks.cmake" 318 ConfigureChecks.cmake"
297 ;; 319 ;;
298 kdebase-runtime) 320 kdebase-runtime)
299 KMEXTRACTONLY="${KMEXTRACTONLY} 321 KMEXTRACTONLY+="
300 config-runtime.h.cmake" 322 config-runtime.h.cmake"
301 ;; 323 ;;
302 kdebase-workspace) 324 kdebase-workspace)
303 KMEXTRACTONLY="${KMEXTRACTONLY} 325 KMEXTRACTONLY+="
304 config-unix.h.cmake 326 config-unix.h.cmake
305 ConfigureChecks.cmake 327 ConfigureChecks.cmake
306 config-workspace.h.cmake 328 config-workspace.h.cmake
307 config-X11.h.cmake 329 config-X11.h.cmake
308 startkde.cmake" 330 startkde.cmake
331 KDE4WorkspaceConfig.cmake.in"
332 ;;
333 kdegames)
334 if [[ ${PN} != libkdegames ]]; then
335 KMEXTRACTONLY+="
336 libkdegames/"
337 fi
338 ;;
339 kdepim)
340 if [[ ${PN} != libkdepim ]]; then
341 KMEXTRACTONLY+="
342 libkdepim/"
343 fi
309 case ${SLOT} in 344 case ${SLOT} in
310 4.2) 345 4.3|4.4|live)
311 KMEXTRACTONLY="${KMEXTRACTONLY} 346 KMEXTRACTONLY+="
312 KDE4WorkspaceConfig.cmake.in" 347 kdepim-version.h
348 config-enterprise.h.cmake"
313 ;; 349 ;;
314 *) : ;;
315 esac 350 esac
316 ;; 351 KMEXTRACTONLY+="
317 kdegames) 352 kleopatra/ConfigureChecks.cmake"
318 if [[ ${PN} != "libkdegames" ]]; then 353 if has kontact ${IUSE//+} && use kontact; then
319 KMEXTRACTONLY="${KMEXTRACTONLY} 354 KMEXTRA+="
320 libkdegames" 355 kontact/plugins/${PLUGINNAME:-${PN}}/"
356 if ! slot_is_at_least 4.4 ${SLOT}; then
357 KMEXTRACTONLY+="
358 kontactinterfaces/"
359 fi
321 fi 360 fi
322 ;; 361 ;;
323 kdepim) 362 kdeutils)
324 KMEXTRACTONLY="${KMEXTRACTONLY} 363 case ${SLOT} in
325 kleopatra/ConfigureChecks.cmake 364 4.3|4.4|live)
326 libkdepim/kdepim_export.h" 365 KMEXTRACTONLY+="
327 if has kontact ${IUSE//+} && use kontact; then 366 kdeutils-version.h"
328 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 367 ;;
329 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/" 368 esac
330 fi
331 ;; 369 ;;
332 koffice) 370 koffice)
333 KMEXTRACTONLY="${KMEXTRACTONLY} 371 KMEXTRACTONLY+="
334 config-endian.h.cmake 372 config-endian.h.cmake
335 filters/config-filters.h.cmake 373 filters/config-filters.h.cmake
336 config-openctl.h.cmake
337 config-openexr.h.cmake 374 config-openexr.h.cmake
338 config-opengl.h.cmake 375 config-opengl.h.cmake
339 config-prefix.h.cmake" 376 config-prefix.h.cmake
377 "
340 case ${PN} in 378 case ${PV} in
341 koffice-libs|koffice-data) 379 2.0.*)
380 KMEXTRACTONLY+="
381 config-openctl.h.cmake"
342 ;; 382 ;;
343 *)
344 # add basic extract for all packages
345 KMEXTRACTONLY="${KMEXTRACTONLY}
346 filters/
347 libs/
348 plugins/"
349 if [[ ${PN} != "kplato" ]]; then
350 KMEXTRA="${KMEXTRA} filters/${PN}"
351 fi
352 ;;
353 esac 383 esac
354 ;; 384 ;;
355 esac 385 esac
356 # Don't install cmake modules for split ebuilds, to avoid collisions. 386 # Don't install cmake modules for split ebuilds, to avoid collisions.
357 case ${KMNAME} in 387 case ${KMNAME} in
388 kdepim)
389 # No need for unpack since 4.2.86
390 # Remove when 4.2 is wiped out from the tree
391 case ${PV} in
392 4.2.[0-4])
393 KMCOMPILEONLY+="
394 cmake/modules/"
395 ;;
396 esac
397 ;;
358 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 398 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
359 case ${PN} in 399 case ${PN} in
360 libkdegames|libkdeedu|marble|libkworkspace) 400 libkdegames|libkdeedu|libkworkspace)
361 KMEXTRA="${KMEXTRA} 401 KMEXTRA+="
362 cmake/modules/" 402 cmake/modules/"
363 ;; 403 ;;
364 *) 404 *)
365 KMCOMPILEONLY="${KMCOMPILEONLY} 405 KMCOMPILEONLY+="
366 cmake/modules/" 406 cmake/modules/"
367 ;; 407 ;;
368 esac 408 esac
369 ;; 409 ;;
370 esac 410 esac
371 411
372 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 412 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
373} 413}
374 414
375__list_needed_subdirectories() { 415__list_needed_subdirectories() {
376 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 416 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
377 417
378 # We expand KMEXTRA by adding CMakeLists.txt files 418 # We expand KMEXTRA by adding CMakeLists.txt files
379 kmextra="${KMEXTRA}" 419 kmextra="${KMEXTRA}"
380 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 420 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
381 for i in ${kmextra}; do 421 for i in ${kmextra}; do
382 kmextra_expanded="${kmextra_expanded} ${i}" 422 kmextra_expanded+=" ${i}"
383 j=$(dirname ${i}) 423 j=$(dirname ${i})
384 while [[ ${j} != "." ]]; do 424 while [[ ${j} != "." ]]; do
385 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 425 kmextra_expanded+=" ${j}/CMakeLists.txt";
386 j=$(dirname ${j}) 426 j=$(dirname ${j})
387 done 427 done
388 done 428 done
389 429
390 # Expand KMMODULE 430 # Expand KMMODULE
391 if [[ -n $KMMODULE ]]; then 431 if [[ -n ${KMMODULE} ]]; then
392 kmmodule_expanded="${KMMODULE}" 432 kmmodule_expanded="${KMMODULE}"
393 j=$(dirname ${KMMODULE}) 433 j=$(dirname ${KMMODULE})
394 while [[ ${j} != "." ]]; do 434 while [[ ${j} != "." ]]; do
395 kmmodule_expanded="${kmmodule_expanded} $j/CMakeLists.txt"; 435 kmmodule_expanded+=" ${j}/CMakeLists.txt";
396 j=$(dirname $j) 436 j=$(dirname ${j})
397 done 437 done
398 fi 438 fi
399 439
400 # Expand KMCOMPILEONLY 440 # Expand KMCOMPILEONLY
401 for i in ${KMCOMPILEONLY}; do 441 for i in ${KMCOMPILEONLY}; do
402 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 442 kmcompileonly_expanded+=" ${i}"
403 j=$(dirname ${i}) 443 j=$(dirname ${i})
404 while [[ ${j} != "." ]]; do 444 while [[ ${j} != "." ]]; do
405 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 445 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
406 j=$(dirname ${j}) 446 j=$(dirname ${j})
407 done 447 done
408 done 448 done
409 449
410 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 450 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
411 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 451 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
412 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 452 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
413 453
414
415 case ${PV} in
416 scm|9999*) : ;;
417 *) topdir="${KMNAME}-${PV}/" ;;
418 esac
419
420 # Create final list of stuff to extract 454 # Create final list of stuff to extract
455 # We append topdir only when specified (usually for tarballs)
421 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 456 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
422 ${KMEXTRACTONLY} 457 ${KMEXTRACTONLY}
423 do 458 do
424 extractlist="${extractlist} ${topdir}${i}" 459 extractlist+=" ${topdir}${moduleprefix}${i}"
425 done 460 done
426 461
427 echo ${extractlist} 462 echo ${extractlist}
428} 463}
429 464
434 debug-print-function ${FUNCNAME} "$@" 469 debug-print-function ${FUNCNAME} "$@"
435 470
436 kde4-meta_change_cmakelists 471 kde4-meta_change_cmakelists
437 kde4-base_src_prepare 472 kde4-base_src_prepare
438} 473}
439
440 474
441# FIXME: no comment here? 475# FIXME: no comment here?
442_change_cmakelists_parent_dirs() { 476_change_cmakelists_parent_dirs() {
443 debug-print-function ${FUNCNAME} "$@" 477 debug-print-function ${FUNCNAME} "$@"
444 478
454 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 488 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
455 fi 489 fi
456 done 490 done
457} 491}
458 492
459# FIXME: add description
460# @FUNCTION: kde4-meta_change_cmakelists 493# @FUNCTION: kde4-meta_change_cmakelists
461# @DESCRIPTION: 494# @DESCRIPTION:
495# Adjust CMakeLists.txt to comply to our splitting.
462kde4-meta_change_cmakelists() { 496kde4-meta_change_cmakelists() {
463 debug-print-function ${FUNCNAME} "$@" 497 debug-print-function ${FUNCNAME} "$@"
464 498
465 pushd "${S}" > /dev/null 499 pushd "${S}" > /dev/null
466 500
467 comment_all_add_subdirectory ./ 501 comment_all_add_subdirectory ./
468 502
469 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 503 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
470 if [[ -f "${S}"/CMakeLists.txt ]]; then 504 if [[ -f CMakeLists.txt ]]; then
471 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 505 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
472 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 506 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
473 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 507 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
474 fi 508 fi
475 509
476 if [[ -z ${KMNOMODULE} ]]; then 510 if [[ -z ${KMNOMODULE} ]]; then
477 # Restore "add_subdirectory" in $KMMODULE subdirectories 511 # Restore "add_subdirectory" in $KMMODULE subdirectories
478 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 512 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
513 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
479 die "${LINENO}: died in KMMODULE section" 514 die "${LINENO}: died in KMMODULE section"
480 _change_cmakelists_parent_dirs ${KMMODULE} 515 _change_cmakelists_parent_dirs ${KMMODULE}
481 fi 516 fi
482 517
518 local i
519
520 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
521 for i in ${KMEXTRACTONLY}; do
522 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
523 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
524 -i ${i}/../CMakeLists.txt || \
525 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
526 fi
527 done
528
483 # KMCOMPILEONLY 529 # KMCOMPILEONLY
484 local i
485 for i in ${KMCOMPILEONLY}; do 530 for i in ${KMCOMPILEONLY}; do
486 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 531 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
487 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 532 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
488 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 533 find "${S}"/${i} -name CMakeLists.txt -print0 | \
489 xargs -0 sed -i \ 534 xargs -0 sed -i \
506 # KMEXTRA_NONFATAL section 551 # KMEXTRA_NONFATAL section
507 for i in ${KMEXTRA_NONFATAL}; do 552 for i in ${KMEXTRA_NONFATAL}; do
508 if [[ -d "${S}"/${i} ]]; then 553 if [[ -d "${S}"/${i} ]]; then
509 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 554 find "${S}"/${i} -name CMakeLists.txt -print0 | \
510 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 555 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
511 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 556 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
512 _change_cmakelists_parent_dirs ${i} 557 _change_cmakelists_parent_dirs ${i}
513 fi
514 done
515
516 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
517 for i in ${KMEXTRACTONLY}; do
518 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
519 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
520 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
521 fi 558 fi
522 done 559 done
523 560
524 case ${KMNAME} in 561 case ${KMNAME} in
525 kdebase-workspace) 562 kdebase-workspace)
526 # COLLISION PROTECT section 563 # COLLISION PROTECT section
527 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 564 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
528 # not as a part of every package. 565 # not as a part of every package.
529 if [[ ${PN} != "kdebase-startkde" && -f "${S}"/CMakeLists.txt ]]; then 566 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
530 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 567 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
531 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 568 sed -e '/startkde/s/^/#DONOTINSTALL /' \
532 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 569 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
533 fi 570 fi
534 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 571 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
535 if [[ ${SLOT} == 4.2 ]] || [[ ${PV} == 9999 ]]; then
536 if [[ ${PN} != libkworkspace ]]; then 572 if [[ ${PN} != libkworkspace ]]; then
537 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 573 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
538 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 574 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
539 fi
540 fi 575 fi
541 ;; 576 ;;
542 kdebase-runtime) 577 kdebase-runtime)
543 # COLLISION PROTECT section 578 # COLLISION PROTECT section
544 # Only install the kde4 script as part of kde-base/kdebase-data 579 # Only install the kde4 script as part of kde-base/kdebase-data
545 if [[ ${PN} != "kdebase-data" && -f "${S}"/CMakeLists.txt ]]; then 580 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
546 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 581 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
547 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 582 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
548 fi 583 fi
584 ;;
585 kdenetwork)
586 # Disable hardcoded kdepimlibs check
587 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
588 -i CMakeLists.txt || die "failed to disable hardcoded checks"
549 ;; 589 ;;
550 kdepim) 590 kdepim)
551 case ${PN} in 591 case ${PN} in
552 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 592 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
553 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 593 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
554 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 594 -e '/add_custom_target(kmail_xml /,/)/p' \
595 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
555 _change_cmakelists_parent_dirs kmail 596 _change_cmakelists_parent_dirs kmail
556 ;; 597 ;;
557 esac 598 esac
558 ;; 599 ;;
600 kdewebdev)
601 # Disable hardcoded kdepimlibs check
602 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
603 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
604 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
605 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
606 -i CMakeLists.txt || die "failed to disable hardcoded checks"
607 ;;
608 koffice)
609 # prevent collisions
610 if [[ ${PN} != koffice-data ]]; then
611 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
612 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
613 sed -e '/install(.\+config-openexr\.h.\+)/d' \
614 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
615 fi
616 # koffice 2.0
617 case ${PV} in
618 2.0.[1-9])
619 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
620 "${S}"/CMakeLists.txt || \
621 die "${LINENO}: sed died in collision prevention section"
622 ;;
623 *) ;;
624 esac
559 esac 625 esac
560 626
561 popd > /dev/null 627 popd > /dev/null
562} 628}
563 629
564# @FUNCTION: kde4-meta_src_configure 630# @FUNCTION: kde4-meta_src_configure
565# @DESCRIPTION: 631# @DESCRIPTION:
566# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 632# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
567# ebuilds. 633# ebuilds.
568kde4-meta_src_configure() { 634kde4-meta_src_configure() {
569 debug-print-function ${FUNCNAME} "$@" 635 debug-print-function ${FUNCNAME} "$@"
636
637 # backwards-compatibility: make mycmakeargs an array, if it isn't already
638 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
639 mycmakeargs=(${mycmakeargs})
640 fi
641
642 # Set some cmake default values here (usually workarounds for automagic deps)
643 case ${KMNAME} in
644 kdewebdev)
645 mycmakeargs=(
646 -DWITH_KdepimLibs=OFF
647 -DWITH_LibXml2=OFF
648 -DWITH_LibXslt=OFF
649 -DWITH_Boost=OFF
650 -DWITH_LibTidy=OFF
651 "${mycmakeargs[@]}"
652 )
653 ;;
654 esac
570 655
571 kde4-base_src_configure 656 kde4-base_src_configure
572} 657}
573 658
574# @FUNCTION: kde4-meta_src_compile 659# @FUNCTION: kde4-meta_src_compile
575# @DESCRIPTION: 660# @DESCRIPTION:
576# General function for compiling split KDE4 applications. 661# General function for compiling split KDE4 applications.
577# Overrides kde4-base_src_compile. 662# Overrides kde4-base_src_compile.
578kde4-meta_src_compile() { 663kde4-meta_src_compile() {
579 debug-print-function ${FUNCNAME} "$@" 664 debug-print-function ${FUNCNAME} "$@"
580 665
581 kde4-base_src_make 666 kde4-base_src_compile "$@"
582} 667}
583 668
584# @FUNCTION: kde4-meta_src_test 669# @FUNCTION: kde4-meta_src_test
585# @DESCRIPTION: 670# @DESCRIPTION:
586# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 671# Currently just calls its equivalent in kde4-base.eclass(5) if
587# ebuilds. 672# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
588kde4-meta_src_test() { 673kde4-meta_src_test() {
589 debug-print-function $FUNCNAME "$@" 674 debug-print-function $FUNCNAME "$@"
590 675
676 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
591 kde4-base_src_test 677 kde4-base_src_test
678 else
679 einfo "Tests disabled"
680 fi
592} 681}
593 682
594# @FUNCTION: kde4-meta_src_install 683# @FUNCTION: kde4-meta_src_install
595# @DESCRIPTION: 684# @DESCRIPTION:
596# Function for installing KDE4 split applications. 685# Function for installing KDE4 split applications.
597kde4-meta_src_install() { 686kde4-meta_src_install() {
598 debug-print-function $FUNCNAME "$@" 687 debug-print-function $FUNCNAME "$@"
599 688
600 kde4-meta_src_make_doc 689 kde4-base_src_install
601 cmake-utils_src_install
602
603 if [[ -n ${KMSAVELIBS} ]]; then
604 install_library_dependencies
605 fi
606
607 # remove unvanted koffice stuff
608 if [[ $KMNAME = koffice && $PN != koffice-data ]]; then
609 rm "$D/$KDEDIR/include/config-openexr.h"
610 rm "$D/$KDEDIR/share/apps/cmake/modules/FindKOfficeLibs.cmake"
611 fi
612} 690}
613 691
614# @FUNCTION: kde4-meta_src_make_doc 692# @FUNCTION: kde4-meta_src_make_doc
615# @DESCRIPTION: 693# @DESCRIPTION:
616# This function searches in ${S}/${KMMODULE}, 694# This function searches in ${S}/${KMMODULE},
617# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist. 695# and tries to install "AUTHORS ChangeLog* README* NEWS TODO" if these files exist.
618kde4-meta_src_make_doc() { 696kde4-meta_src_make_doc() {
619 debug-print-function $FUNCNAME "$@" 697 debug-print-function ${FUNCNAME} "$@"
620 698
621 local doc 699 local doc
622 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 700 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
623 [[ -s ${KMMODULE}/$doc ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 701 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
624 done 702 done
625 703
626 kde4-base_src_make_doc 704 kde4-base_src_make_doc
627} 705}
628 706
629# @FUNCTION: kde4-meta_pkg_postinst 707# @FUNCTION: kde4-meta_pkg_postinst
630# @DESCRIPTION: 708# @DESCRIPTION:
631# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 709# Invoke kbuildsycoca4.
632# ebuilds.
633kde4-meta_pkg_postinst() { 710kde4-meta_pkg_postinst() {
711 debug-print-function ${FUNCNAME} "$@"
712
634 kde4-base_pkg_postinst 713 kde4-base_pkg_postinst
635} 714}
636 715
637# @FUNCTION: kde4-meta_pkg_postrm 716# @FUNCTION: kde4-meta_pkg_postrm
638# @DESCRIPTION: 717# @DESCRIPTION:
639# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 718# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
640# ebuilds. 719# ebuilds.
641kde4-meta_pkg_postrm() { 720kde4-meta_pkg_postrm() {
721 debug-print-function ${FUNCNAME} "$@"
722
642 kde4-base_pkg_postrm 723 kde4-base_pkg_postrm
643} 724}
644

Legend:
Removed from v.1.10  
changed lines
  Added in v.1.32

  ViewVC Help
Powered by ViewVC 1.1.20